/* expsens.c */

/* 
  maintained by Fred Martin (fredm@media.mit.edu)

  VERSION HISTORY
  
  June 12, 1998		fredm
  first version created

*/

int analog(int port)
{
	if (port < 2) {
		printf("Port is in use  by expansion bd\n");
		beep();
		return -1;
	} else if (port < 7) {
    	return _raw_analog(port);
    } else if (port < 16) {
    	return 255 * !digital(port);
    } else if (port < 24) {
    	return _exp_analog((port-16)<<8);
    } else if (port < 32) {
    	return _exp_analog(((port-24)<<8)+1);
    } else {
    	printf("Analog port out of range\n");
    	beep();
    	return -1;
    }
}

int digital(int port)
{
    if (port < 7) /* analogs */
    	return analog(port) < 128;
    if (port == 7) /* TIC1 */
    	return !(peek(0x1000) & 1);
    if (port == 8) /* TIC2 */
    	return !(peek(0x1000) & 2);
    if (port == 9) /* PAI */
    	return !(peek(0x1000) & 128);
    if (port < 16) /* normal bit of 7fff as gotten from digital chip */
      return !((peek(0x7fff) >> (port - 10)) & 1);
    if (port < 32) /* expbd analogs */
      return analog(port) < 128;
    else {
	printf("Digital port outof range\n");
	beep();
	return -1;
    }
}

